#ifndef SOUNDCONTROL_CLASS_H
#define SOUNDCONTROL_CLASS_H

#include "SDL/SDL.h"
#include "SDL/SDL_mixer.h"
#include <stdio.h>

class SoundControl {
 public:
  static SoundControl* getInstance();
  static void deleteInstance();
  
  void setNumberOfChannels(int number_of_channels);
  static void playMod(char* filename);
  static void playWav(char* filename);
  static void playOgg(char* filename);
  void volumeUp();
  void volumeDown();
  void trackRewind();
  void forwardMusic();
  void rewindMusic();
  void pauseMusic();
  void resumeMusic();
  void fadeInMusic(int time);
  void fadeOutMusic(int time);
  static void musicDone();
  
  void handleKey(SDL_KeyboardEvent key); 
  int main(int argc, char* argv[]);
  
  static SoundControl* sound;
  int volume;
  int track_number;
  int audio_rate, audio_channels, audio_buffers;
  int done;
  Uint16 audio_format;
  int sfx_channel1;
  int sfx_channel2;
  int finished;

 protected:
  SoundControl();
  ~SoundControl();
  void initialise();

 private:
  static SoundControl* instance;
};

#endif
